#include "uart1.h"
#include "System/lpc214x.h"	// PCLK
#include <stdlib.h>
#include "FreeRTOS\task.h"
#include "FreeRTOS\FreeRTOS.h"


char uart1Init (unsigned long baudRate)
{
	// TODO 1.  Initialize UART with the given baud rate
	// Note: PCLK is already defined
	PINSEL0 &= ~(0xF << 16);	//unset B19:B16
	PINSEL0 |= (5 << 16);	//set B19:B16 to 0101 to select UART1 Rx/Tx

	U1LCR |= (1 << 7); //set DLAB = 1 to modify baudrate
	//Modify baudrate
	U1DLL = PCLK/(16*baudRate);
	U1DLM = 0;
	U1LCR &= ~(1 << 7); //set DLBA = 0 to access Rx/Tx registers

	U1LCR = 3; //sets LCR to 8-bit word length, 1 stop bit, no parity
}

unsigned long uart1GetChar (char *pcRxedChar, portTickType xBlockTime)
{
	// TODO 2.  Wait until UART captures a char, and store it to pcRxedChar
	// Ignore the Block time variable
	while (!(U1LSR & (1<<0)));
	*pcRxedChar = U1RBR;
}

unsigned long uart1PutChar (char cOutChar, portTickType xBlockTime)
{
	// TODO 3.  Send a char out the UART
	// Ignore the Block time variable
	while (!(U1LSR & (1<<5)));
	U1THR = cOutChar;
}
